Subject: RE: I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

From: Sikhivahan Gundu <[email-masked]>
Date: Tue, 1 Aug 2017 07:42:04 +0000

Hi,

The draft mandates using "post-convergence path" as the backup path.

It states one advantage, among others, of doing so as follows:

"This .. helps to reduce the amount of path changes and hence service

transients: one transition (pre-convergence to post-convergence) instead

of two (pre-convergence to FRR and then post-convergence)".

This suggests to me that the assumption here is that the post-convergence

path can be uniquely determined in advance.

However, SRLG introduces ambiguity. To illustrate the point,  let us say a

loop-free alternative has two options: one  link (L1) is of the same metric

value as the primary link and is also in the same SRLG as the primary; the

second option (L2) is in a different SRLG and has higher metric.

The actual post-convergence path would depend on whether or not L1

also failed along with the primary, so is not uniquely computed in advance.

If TI-LFA picks L1, there might not be a guaranteed backup. If it picks L2,

there'd be two link transitions because L2 would not be in a (strict) SPF-

computed post-convergence path. A third option, of course, is to give up

declaring that there is no TI-LFA backup, but it'd be preferable to have

some backup than have none at all.

What do the authors suggest for this situation?

Thanks,

Sikhi

From: rtgwg [mailto:[email-masked]] On Behalf Of Ahmed Bashandy (bashandy)
Sent: 17 July 2017 12:56
To: [email-masked]
Cc: [email-masked]; [email-masked]; Stewart Bryant <[email-masked]>
Subject: Fwd: I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

Hi,
A new version of the ti-lfa draft has been posted to address Stewart Bryant's comments

Thanks

Ahmed

-------- Original Message --------
Subject:

I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

Date:

Mon, 17 Jul 2017 00:19:37 -0700

From:

[email-masked]<mailto:[email-masked]>

Reply-To:

[email-masked]<mailto:[email-masked]>

To:

<[email-masked]><mailto:[email-masked]>

A New Internet-Draft is available from the on-line Internet-Drafts directories.

        Title           : Topology Independent Fast Reroute using Segment Routing

        Authors         : Ahmed Bashandy

                          Clarence Filsfils

                          Bruno Decraene

                          Stephane Litkowski

                          Pierre Francois

        Filename        : draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

        Pages           : 12

        Date            : 2017-07-17

Abstract:

   This document presents Topology Independent Loop-free Alternate Fast

   Re-route (TI-LFA), aimed at providing protection of node and

   adjacency segments within the Segment Routing (SR) framework.  This

   Fast Re-route (FRR) behavior builds on proven IP-FRR concepts being

   LFAs, remote LFAs (RLFA), and remote LFAs with directed forwarding

   (DLFA).  It extends these concepts to provide guaranteed coverage in

   any IGP network.  A key aspect of TI-LFA is the FRR path selection

   approach establishing protection over post-convergence paths from

   the point of local repair, dramatically reducing the operational

   need to control the tie-breaks among various FRR options.

The IETF datatracker status page for this draft is:

https://datatracker.ietf.org/doc/draft-bashandy-rtgwg-segment-routing-ti-lfa/

There are also htmlized versions available at:

https://tools.ietf.org/html/draft-bashandy-rtgwg-segment-routing-ti-lfa-01

https://datatracker.ietf.org/doc/html/draft-bashandy-rtgwg-segment-routing-ti-lfa-01

A diff from the previous version is available at:

https://www.ietf.org/rfcdiff?url2=draft-bashandy-rtgwg-segment-routing-ti-lfa-01

Please note that it may take a couple of minutes from the time of submission

until the htmlized version and diff are available at tools.ietf.org.

Internet-Drafts are also available by anonymous FTP at:

ftp://ftp.ietf.org/internet-drafts/

_______________________________________________

I-D-Announce mailing list

[email-masked]<mailto:[email-masked]>

https://www.ietf.org/mailman/listinfo/i-d-announce

Internet-Draft directories: http://www.ietf.org/shadow.html

or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

---

From: "Ahmed Bashandy (bashandy)" <[email-masked]>
Date: Fri, 04 Aug 2017 12:49:04 -0700

HI,

All members of the same SRLG group are assumed to fail if one of them fails.

Going back to you example
- L1 is in the same SRLG group as the primary link while L2 is belongs a 
different group
- Hence if the primary link fails, only "L1" will fail and L2 will not
- Hence only L2 is candidate to become a backup path while L1 is not
- Hence there is no ambiguity

Thanks

Ahmed

On 8/1/2017 12:42 AM, Sikhivahan Gundu wrote:
> *From:*rtgwg [mailto:[email-masked]] *On Behalf Of *Ahmed 
> Bashandy (bashandy)
> *Sent:* 17 July 2017 12:56
> *To:* [email-masked]
> *Cc:* [email-masked]; [email-masked]; Stewart Bryant 
> <[email-masked]>
> *Subject:* Fwd: I-D Action: 
> draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt
>
> Hi,
>
> *Subject: *
> *Date: *
> *From: *
> [email-masked] <mailto:[email-masked]>
>
> *Reply-To: *
>
> 	
>
> [email-masked] <mailto:[email-masked]>
>
> *To: *
>
> 	
>
> <[email-masked]> <mailto:[email-masked]>
>
> [email-masked]  <mailto:[email-masked]>
> Internet-Draft directories:http://www.ietf.org/shadow.html
> orftp://ftp.ietf.org/ietf/1shadow-sites.txt
>

---

From: Sikhivahan Gundu <[email-masked]>
Date: Mon, 7 Aug 2017 05:45:00 +0000

Hi,

Thanks for your response.

>> - Hence if the primary link fails, only "L1" will fail and L2 will not

L1 _may_ fail, with high probability, but it may also not fail. If it does
not fail, there is a second transitioning of the post-primary-failure
link from FRR-backup (L2) to post-convergence link (L1), because L1
has a smaller metric.

By "ambiguity", I meant that backup calculation taking SRLG into
account is  based on speculated topology,  whereas computation of
post-convergence path, ie, SPF, is based on actual topology.  This
seems needs reconciling since in  TI-LFA the backup is by definition
the post-convergence path, with a single path-transition after
link-failure as the intended outcome. Do I understand correctly that
the draft prefers to relax that expectation for SRLG?

Thanks,
Sikhi

From: Ahmed Bashandy (bashandy) [mailto:[email-masked]]
Sent: 05 August 2017 01:19
To: Sikhivahan Gundu <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; Stewart Bryant <[email-masked]>
Subject: Re: I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

HI,

- L1 is in the same SRLG group as the primary link while L2 is belongs a different group

Thanks

Ahmed

Hi,

Thanks,

Sikhi

From: rtgwg [mailto:[email-masked]] On Behalf Of Ahmed Bashandy (bashandy)
Sent: 17 July 2017 12:56
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Stewart Bryant <[email-masked]><mailto:[email-masked]>
Subject: Fwd: I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

Hi,

Thanks

Ahmed

-------- Original Message --------
Subject:

Date:

From:

Reply-To:

To:

        Authors         : Ahmed Bashandy

                          Clarence Filsfils

                          Bruno Decraene

                          Stephane Litkowski

                          Pierre Francois

        Pages           : 12

        Date            : 2017-07-17

Abstract:

---

From: Stewart Bryant <[email-masked]>
Date: Mon, 7 Aug 2017 10:13:57 +0100

On 07/08/2017 06:45, Sikhivahan Gundu wrote:
>
> By “ambiguity”, I meant that backup calculation taking SRLG into
>

Yes, that is a good point, in the event of an incomplete failure
of an SRLG, there may not be congruence between the
FRR path and the post convergence path. This certainly
needs further study.

   *
A--------//---------B
|                   |
|  *                | cost 2
C-------------------D
|                   |
|                   | cost 100
E-------------------F

AB + CD in same SRLG

TiLFA path is ACEFDB

Post convergence path is ACDB

In this case I think that the impact is just more SR hops in the
repair path than might be needed without the SRLG, but we do need to
be sure  that there are no pathological  cases in
topologies that lack the proposed congruence, and as
Sikhivahan notes this effect does need to be clarified in the
text.

- Stewart

---

From: "Ahmed Bashandy (bashandy)" <[email-masked]>
Date: Mon, 07 Aug 2017 11:23:11 -0700

I am not aware of such thing as "speculative, ambiguous, probabilistic, 
stocastic,..., etc" SRLG.

SRLG is one member fails, all members fail. I presumed that this is 
understood from the many responses and discussions that we had. However 
I will explicitly define the term "SRLG" in the draft

Thanks

Ahmed

On 8/6/2017 10:45 PM, Sikhivahan Gundu wrote:
> L1 _/may/_ fail, with high probability, but it may also not fail. If 
> it does
>
> *From:*Ahmed Bashandy (bashandy) [mailto:[email-masked]]
> *Sent:* 05 August 2017 01:19
> *To:* Sikhivahan Gundu <[email-masked]>; [email-masked]
> *Subject:* Re: I-D Action: 
>     *To:* [email-masked] <mailto:[email-masked]>
>     *Cc:* [email-masked] <mailto:[email-masked]>;
>     [email-masked] <mailto:[email-masked]>; Stewart Bryant
>     <[email-masked]> <mailto:[email-masked]>

---

From: "Ahmed Bashandy (bashandy)" <[email-masked]>
Date: Mon, 07 Aug 2017 11:23:44 -0700

See my reply to Sikhi

Thanks

Ahmed

---

From: Stewart Bryant <[email-masked]>
Date: Mon, 7 Aug 2017 20:47:08 +0100

On 07/08/2017 19:23, Ahmed Bashandy (bashandy) wrote:
> I am not aware of such thing as "speculative, ambiguous, 
> probabilistic, stocastic,..., etc" SRLG.
>
> understood from the many responses and discussions that we had. 
> However I will explicitly define the term "SRLG" in the draft

No. SRLG is where when one member fails you treat as if all members have 
failed. Routing then works out what actually happened.

- Stewart

>>     The draft mandates using “post-convergence path” as the backup path.
>>
>>     “This .. helps to reduce the amount of path changes and hence
>>     service
>>
>>     of two (pre-convergence to FRR and then post-convergence)”.
>>
>>     there’d be two link transitions because L2 would not be in a
>>     (strict) SPF-
>>
>>     declaring that there is no TI-LFA backup, but it’d be preferable
>>     to have
>>
> rtgwg mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtgwg

---

From: Stewart Bryant <[email-masked]>
Date: Mon, 7 Aug 2017 20:48:17 +0100

Your answer did not address the issue below, which is one of a class of 
issues related to SRLG.

- Stewart

---

From: "Ahmed Bashandy (bashandy)" <[email-masked]>
Date: Mon, 7 Aug 2017 20:04:32 +0000

Stewart

I already replied to Sikhi explaining the concept of the SRLG used in this draft and the intent to make it even clearer.

IMO the scope of the draft is very clear from the draft itself as well as the numerous responses during the previous IETF and the mailing list.

The issue below is *out of scope* of the draft and hence I have no plans on addressing it.

I hope you don't insist on pushing out-of-scope topics down the throat of this draft :)

Ahmed

From: Stewart Bryant [mailto:[email-masked]]
Sent: Monday, August 07, 2017 12:48 PM
To: Ahmed Bashandy (bashandy); Stewart Bryant; Sikhivahan Gundu; [email-masked]
Cc: [email-masked]; [email-masked]
Subject: Re: I-D Action: draft-bashandy-rtgwg-segment-routing-ti-lfa-01.txt

Your answer did not address the issue below, which is one of a class of issues related to SRLG.

- Stewart

Thanks

Ahmed

   *
A--------//---------B
|                   |
|  *                | cost 2
C-------------------D
|                   |
|                   | cost 100
E-------------------F

AB + CD in same SRLG

TiLFA path is ACEFDB

- Stewart

rtgwg mailing list

[email-masked]<mailto:[email-masked]>

---

From: Stewart Bryant <[email-masked]>
Date: Mon, 7 Aug 2017 21:34:19 +0100

Ahmed,

The WG decides what is in or out of scope for a WG draft, and it does 
this via the rough consensus of the WG, not the view of the authors.

Of course if you wish to refocus this as an independent draft and submit 
via the ISE. If you do, you are welcome and I will leave you to it.

Meanwhile the draft really has to discuss SRLGs are they are in real 
life, not as you would wish them to be.

Another type of false SRLG btw is when you are doing node protection 
(you normally treat a node as an SRLG), but only a line interface has 
failed.

- Stewart

On 07/08/2017 21:04, Ahmed Bashandy (bashandy) wrote:
>
> Stewart
>
> I already replied to Sikhi explaining the concept of the SRLG used in 
> this draft and the intent to make it even clearer.
>
> IMO the scope of the draft is very clear from the draft itself as well 
> as the numerous responses during the previous IETF and the mailing list.
>
> The issue below is **out of scope** of the draft and hence I have no 
> plans on addressing it.
>
> I hope you don’t insist on pushing out-of-scope topics down the throat 
> of this draft :)
>
> Ahmed
>
> *From:*Stewart Bryant [mailto:[email-masked]]
> *Sent:* Monday, August 07, 2017 12:48 PM
> *To:* Ahmed Bashandy (bashandy); Stewart Bryant; Sikhivahan Gundu; 
> [email-masked]
> *Cc:* [email-masked]; [email-masked]
>     [email-masked] <mailto:[email-masked]>
>

---

From: "Ahmed Bashandy (bashandy)" <[email-masked]>
Date: Tue, 15 Aug 2017 09:23:50 -0700

Stewart

If you think that there are other problems that needs to be addressed, 
do not attempt to push it down the throat of our draft. Instead put out 
your own proposal. But make sure that it has enough merit to convince 
the WG that it is better or more comprehensive instead of attempting to 
point out fictitious problems in others' proposals.

Ahmed

On 8/7/2017 1:34 PM, Stewart Bryant wrote:
> Of course if you wish to refocus this as an independent draft and 
> submit via the ISE. If you do, you are welcome and I will leave you to it.
>
>> IMO the scope of the draft is very clear from the draft itself as 
>> well as the numerous responses during the previous IETF and the 
>> mailing list.
>>
>> I hope you don’t insist on pushing out-of-scope topics down the 
>> throat of this draft :)
>>
>> Ahmed
>>

---

From: Stewart Bryant <[email-masked]>
Date: Tue, 15 Aug 2017 18:17:32 +0100

Ahmed,

Let us consider this "fiction".

RFC4202 section 2.3 defines a shared risk link group as:

"A set of links may constitute a 'shared risk link group' (SRLG) if they 
share a resource whose failure may affect all links in the set."

The key work is MAY.

This means that there is some probability that all members of the SRLG 
failed, and that there is some other probability that they did not all fail.

In your draft you calculate your repair action on the assumption that 
they all failed and assert that this will be congruent with the post 
convergence path.

However from the definition of SRLG we can see that they may not have 
all failed, in which case some of the not failed elements of the SRLG 
will normally remain in service, and may provide a better path than the 
path avoiding all elements of the SRLG.  If this is the case the 
calculated repair path may not be congruent with the post convergence path.

Thus using the standard definition of SRLG this fundamental assertion in 
your proposal seems to me to fail.

You could introduce and alternative definition of SRLG:

"A set of links may constitute a 'shared risk link group' (SRLG) if  
they share a resource whose failure will effect all links in the set."

However in practice this definition can only be true if on seeing the 
failure of a single element of the SRLG you take all elements of the 
SRLG out of service. This seems wasteful of resources, but if that is 
what you mean your draft needs to specify this definition and action.

Alternatively your draft needs to state that full congruence may not 
occur and analyse the consequences of this.

Regards

Stewart

On 15/08/2017 17:23, Ahmed Bashandy (bashandy) wrote:
> do not attempt to push it down the throat of our draft. Instead put 
> out your own proposal. But make sure that it has enough merit to 
> convince the WG that it is better or more comprehensive instead of 
> attempting to point out fictitious problems in others' proposals.
>
> Ahmed
>
>
>
>>> I already replied to Sikhi explaining the concept of the SRLG used 
>>> in this draft and the intent to make it even clearer.
>>>